var DATA = {};

var SUPPORTED = [
  'gen1randombattle', 'gen2randombattle',  'gen3randombattle',
  'gen4randombattle', 'gen5randombattle', 'gen6randombattle',
  'gen7randombattle', 'gen7letsgorandombattle', 'gen7randomdoublesbattle',
  'gen8bdsprandombattle', 'gen8randombattle', 'gen8randombattleblitz',
  'gen8randombattlenodmax', 'gen8randomdoublesbattle',
];
// Weakness chart
var ShowdownEnhancedTooltip = {};

ShowdownEnhancedTooltip.Settings = {
  showBaseStats: 'OFF',
};

ShowdownEnhancedTooltip.BattleTypeChart = {
  // defending type
  "Bug": {
    damageGiven: {
      // attacking type : effectivenessMultiplier
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 2,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0.5,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"atk":30, "def":30, "spd":30},
    HPdvs: {"atk":13, "def":13},
  },
  "Dark": {
    damageGiven: {
      "Bug": 2,
      "Dark": 0.5,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 2,
      "Fighting": 2,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 0.5,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 0,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {},
  },
  "Dragon": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 2,
      "Electric": 0.5,
      "Fairy": 2,
      "Fighting": 1,
      "Fire": .5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 1,
      "Ice": 2,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 0.5,
    },
    HPivs: {"atk":30},
    HPdvs: {"def":14},
  },
  "Electric": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0.5,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 2,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 0.5,
      "Water": 1,
    },
    HPivs: {"spa":30},
    HPdvs: {"atk":14},
  },
  "Fairy": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 0.5,
      "Dragon": 0,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 2,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 2,
      "Water": 1,
    },
  },
  "Fighting": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 0.5,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 2,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 2,
      "Rock": 0.5,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spa":30, "spd":30, "spe":30},
    HPdvs: {"atk":12, "def":12},
  },
  "Fire": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 1,
      "Fire": 0.5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 0.5,
      "Water": 2,
    },
    HPivs: {"atk":30, "spa":30, "spe":30},
    HPdvs: {"atk":14, "def":12},
  },
  "Flying": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 2,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0,
      "Ice": 2,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"hp":30, "atk":30, "def":30, "spa":30, "spd":30},
    HPdvs: {"atk":12, "def":13},
  },
  "Ghost": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 2,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 2,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 0,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spd":30},
    HPdvs: {"atk":13, "def":14},
  },
  "Grass": {
    damageGiven: {
      "Bug": 2,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0.5,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 2,
      "Flying": 2,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 0.5,
      "Ice": 2,
      "Normal": 1,
      "Poison": 2,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 0.5,
    },
    HPivs: {"atk":30, "spa":30},
    HPdvs: {"atk":14, "def":14},
  },
  "Ground": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 0,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 1,
      "Ice": 2,
      "Normal": 1,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 0.5,
      "Steel": 1,
      "Water": 2,
    },
    HPivs: {"spa":30, "spd":30},
    HPdvs: {"atk":12},
  },
  "Ice": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 2,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 1,
      "Ground": 1,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 2,
      "Steel": 2,
      "Water": 1,
    },
    HPivs: {"atk":30, "def":30},
    HPdvs: {"def":13},
  },
  "Normal": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 0,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
  },
  "Poison": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 1,
      "Normal": 1,
      "Poison": 0.5,
      "Psychic": 2,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"def":30, "spa":30, "spd":30},
    HPdvs: {"atk":12, "def":14},
  },
  "Psychic": {
    damageGiven: {
      "Bug": 2,
      "Dark": 2,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 0.5,
      "Fire": 1,
      "Flying": 1,
      "Ghost": 2,
      "Grass": 1,
      "Ground": 1,
      "Ice": 1,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 0.5,
      "Rock": 1,
      "Steel": 1,
      "Water": 1,
    },
    HPivs: {"atk":30, "spe":30},
    HPdvs: {"def":12},
  },
  "Rock": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 1,
      "Fairy": 1,
      "Fighting": 2,
      "Fire": 0.5,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 2,
      "Ice": 1,
      "Normal": 0.5,
      "Poison": 0.5,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 2,
      "Water": 2,
    },
    HPivs: {"def":30, "spd":30, "spe":30},
    HPdvs: {"atk":13, "def":12},
  },
  "Steel": {
    damageGiven: {
      "Bug": 0.5,
      "Dark": 1,
      "Dragon": 0.5,
      "Electric": 1,
      "Fairy": 0.5,
      "Fighting": 2,
      "Fire": 2,
      "Flying": 0.5,
      "Ghost": 1,
      "Grass": 0.5,
      "Ground": 2,
      "Ice": 0.5,
      "Normal": 0.5,
      "Poison": 0,
      "Psychic": 0.5,
      "Rock": 0.5,
      "Steel": 0.5,
      "Water": 1,
    },
    HPivs: {"spd":30},
    HPdvs: {"atk":13},
  },
  "Water": {
    damageGiven: {
      "Bug": 1,
      "Dark": 1,
      "Dragon": 1,
      "Electric": 2,
      "Fairy": 1,
      "Fighting": 1,
      "Fire": 0.5,
      "Flying": 1,
      "Ghost": 1,
      "Grass": 2,
      "Ground": 1,
      "Ice": 0.5,
      "Normal": 1,
      "Poison": 1,
      "Psychic": 1,
      "Rock": 1,
      "Steel": 0.5,
      "Water": 0.5,
    },
    HPivs: {"atk":30, "def":30, "spa":30},
    HPdvs: {"atk":14, "def":13},
  },
};


ShowdownEnhancedTooltip.getTypeEff = function(types){
  if (types.length == 1){
    var damage = ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven;
  }else{
    var damage = {
      "Bug": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Bug * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Bug,
      "Dark": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Dark * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Dark,
      "Dragon": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Dragon * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Dragon,
      "Electric": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Electric * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Electric,
      "Fairy": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fairy * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fairy,
      "Fighting": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fighting * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fighting,
      "Fire": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Fire * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Fire,
      "Flying": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Flying * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Flying,
      "Ghost": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ghost * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ghost,
      "Grass": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Grass * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Grass,
      "Ground": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ground * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ground,
      "Ice": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Ice * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Ice,
      "Normal": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Normal * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Normal,
      "Poison": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Poison * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Poison,
      "Psychic": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Psychic * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Psychic,
      "Rock": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Rock * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Rock,
      "Steel": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Steel * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Steel,
      "Water": ShowdownEnhancedTooltip.BattleTypeChart[types[0]].damageGiven.Water * ShowdownEnhancedTooltip.BattleTypeChart[types[1]].damageGiven.Water,
    }
  }

  var typeEff = {
    "4": [],
    "2": [],
    "1": [],
    "0.5": [],
    "0.25": [],
    "0": []
  };

  for(var index in damage) {
    var eff = damage[index];
    typeEff[eff].push(index);
  }

  return typeEff;
};

// Random Battle sets are generated based on battle-only forms which makes disambiguating sets
// difficult sometimes. We first try searching by level as sometimes this is sufficient to
// differentiate and then by base species - if there is only one set then we can return it.
// Otherwise, if the Pokémon is not the base forme and there is only one set for that forme we can
// return that. However, if the Pokémon is still in its base forme we return multiple (labelled)
// sets.
var TOOLTIP = undefined;
try { TOOLTIP = BattleTooltips.prototype.showPokemonTooltip; } catch {}
var TOOLTIPMOVE = undefined;
try { TOOLTIPMOVE = BattleTooltips.prototype.showMoveTooltip; } catch {}
if (TOOLTIP) {
  for (var format of SUPPORTED) {
    (function (f) {
      var request = new XMLHttpRequest();
      request.addEventListener('load', function() {
        var data = {};
        var json = JSON.parse(request.responseText);
        for (var name in json) {
          var pokemon = json[name];
          data[pokemon.level] = data[pokemon.level] || {};
          var species = Dex.species.get(name);
          var id = toID(species.forme === 'Gmax'
            ? species.baseSpecies
            : species.battleOnly || species.name);
          data[pokemon.level][id] = data[pokemon.level][id] || [];
          data[pokemon.level][id].push(Object.assign({name: name}, pokemon));
        }
        DATA[f] = data;
      });
      request.open('GET', 'https://pkmn.github.io/randbats/data/' + f + '.json');
      request.send(null);
    })(format);
  }

  BattleTooltips.prototype.showPokemonTooltip = function (clientPokemon, serverPokemon) {
    var original = TOOLTIP.apply(this, arguments);
    if (!clientPokemon || serverPokemon) return original;
    var format = toID(this.battle.tier);
    if (!format || !format.includes('random')) return original;

    var species = Dex.species.get(clientPokemon.speciesForme);
    if (!species) return original;

    var gen = Number(format.charAt(3));
    var letsgo = format.includes('letsgo');
    var gameType = this.battle.gameType;

    if (!['singles', 'doubles'].includes(gameType)) {
      format = 'gen' + gen + 'randomdoublesbattle';
    } else if (format.includes('monotype') || format.includes('unrated')) {
      format = 'gen' + gen + 'randombattle';
    }
    if (!DATA[format]) return original;

    var data = DATA[format][species.name === 'Zoroark' ? 0 : clientPokemon.level];
    if (!data) return original;

    var cosmetic = species.cosmeticFormes && species.cosmeticFormes.includes(species.name);
    var id = toID((species.forme === 'Gmax' || cosmetic)
      ? species.baseSpecies : species.battleOnly || species.name);
    if (id.startsWith('pikachu')) id = id.endsWith('gmax') ? 'pikachugmax' : 'pikachu';
    var forme = cosmetic ? species.baseSpecies : clientPokemon.speciesForme;
    if (forme.startsWith('Pikachu')) forme = forme.endsWith('Gmax') ? 'Pikachu-Gmax' : 'Pikachu';

    data = data[id];
    if (!data) return original;

    if (data.length === 1) {
      data[0].level = clientPokemon.level;
      return original + displaySet(gen, gameType, letsgo, species, data[0], null , this.getPokemonTypes(clientPokemon),clientPokemon);
    }
    if (toID(forme) !== id) {
      var match = [];
      for (var set of data) {
        set.level = clientPokemon.level;
        if (set.name === forme) match.push(displaySet(gen, gameType, letsgo, species, set, null , this.getPokemonTypes(clientPokemon),clientPokemon));
      }
      if (match.length === 1) return original + match[0];
    }
    var buf = original;
    for (var set of data) {
      set.level = clientPokemon.level;
      // Technically different formes will have different base stats, but given at this stage
      // we're still in the base forme we simply use the base forme base stats for everything.
      buf += displaySet(gen, gameType, letsgo, species, set, set.name, this.getPokemonTypes(clientPokemon), clientPokemon);
    }
    return buf;
  }

  function displaySet(gen, gameType, letsgo, species, data, name, types, pokemon) {
    var stats = {};
    for (var stat in species.baseStats) {
      stats[stat] = calc(
        gen,
        stat,
        species.baseStats[stat],
        'ivs' in data && stat in data.ivs ? data.ivs[stat] : (gen < 3 ? 30 : 31),
        'evs' in data && stat in data.evs ? data.evs[stat] : (gen < 3 ? 255 : letsgo ? 0 : 85),
        data.level,
        letsgo);
    }
    var moves = data.moves;
    var noHP = true;
    var multi = !['singles', 'doubles'].includes(gameType);
    var ms = [];
    for (var move of moves) {
      if (move.startsWith('Hidden Power')) noHP = false;
      if (!(multi && move === 'Ally Switch')) ms.push(move);
    }

    var buf = '<div style="border-top: 1px solid #888; background: #dedede">';
    if (name) buf += '<p><b>' + name + '</b></p>';
    if (gen >= 3 && !letsgo) {
      buf += '<p><small>Abilities:</small> ' + data.abilities.join(', ') + '</p>';
    }
    if (gen >= 2 && !(letsgo && !data.items)) {
      buf +=
        '<p><small>Items:</small> ' + (data.items ? data.items.join(', ') : '(No Item)') + '</p>';
    }

    buf += '<p><small>Moves:</small> ' + moves.join(', ') + '</p>';
    
    const typeEff = ShowdownEnhancedTooltip.getTypeEff(types);
    const multiplierKeys = [4, 2, .5, .25, 0];
    buf += '<p>Weaknesses: <br />';
    multiplierKeys.forEach((multiplierKey) => {
      if (typeEff[multiplierKey].length > 0) {
        const weakTypes = typeEff[multiplierKey].map(effect => effect ? Dex.getTypeIcon(effect) : '').join('');
        buf += `<p>${multiplierKey}x: ${weakTypes}</p>`;
        }
    });


    buf += '<p>';
    for (var statName of Dex.statNamesExceptHP) {
      if (gen === 1 && statName === 'spd') continue;
      var known = gen === 1 || (gen === 2 && noHP) ||
        ('ivs' in data && statName in data.ivs) || ('evs' in data && statName in data.evs);
      var statLabel = gen === 1 && statName === 'spa' ? 'spc' : statName;
      buf += statName === 'atk' ? '<small>' : '<small> / ';
      buf += '' + BattleText[statLabel].statShortName + '&nbsp;</small>';
      var italic = !known && (statName === 'atk' || statName === 'spe');
      buf += (italic ? '<i>' : '') + stats[statName] + (italic ? '</i>' : '');
    }
    buf += '</p>';
    if(Object.keys(pokemon.boosts).length != 0){
      buf += '<p>';
      var boostedStats = getStats(gen,gameType,letsgo,species,data,name,types, pokemon);
      buf += pokemon.boosts.atk ? '<a style="color:green"> <small>Atk </small>'+ boostedStats.atk+ "<small> / </small></a>" :'<a> <small>Atk </small>'+ boostedStats.atk+ "<small> / </small></a>" ;
      buf += pokemon.boosts.def ? '<a style="color:green"> <small>Def </small>'+ boostedStats.def+ "<small> / </small></a>" :'<a> <small>Def </small>'+ boostedStats.def+ "<small> / </small></a>" ;
      buf += pokemon.boosts.spa ? '<a style="color:green"> <small>SpA </small>'+ boostedStats.spa+ "<small> / </small></a>" :'<a> <small>SpA </small>'+ boostedStats.spa+ "<small> / </small></a>" ;
      buf += pokemon.boosts.spd ? '<a style="color:green"> <small>SpD </small>'+ boostedStats.spd+ "<small> / </small></a>" :'<a> <small>SpD </small>'+ boostedStats.spd+ "<small> / </small></a>" ;
      buf += pokemon.boosts.spe ? '<a style="color:green"> <small>Spe </small>'+ boostedStats.spe+ "</a>" :'<a> <small>Spe </small>'+ boostedStats.spe+ "</a>" ;
      buf += '</p>';
    }



    buf += '</div>';
    return buf;
  }

  function tr(num) {
    return num >>> 0
  }

  function calc(gen, stat, base, iv, ev, level, letsgo) {
    if (gen < 3) iv = Math.floor(iv / 2) * 2;
    if (stat === 'hp') {
      var val = base === 1 ? base : tr(tr(2 * base + iv + tr(ev / 4) + 100) * level / 100 + 10);
      return letsgo ? val + 20 : val;
    } else {
      var val = tr(tr(2 * base + iv + tr(ev / 4)) * level / 100 + 5);
      return letsgo ? tr(val * 102 / 100) + 20 : val;
    }
  }


  BattleTooltips.prototype.showMoveTooltip = function (clientMove, serverMove, clientPokemon, serverPokemon) {
    var original = TOOLTIPMOVE.apply(this, arguments);
    if(clientMove.basePower == 0 ||clientMove.basePower == null || clientMove.basePower > undefined){
      return original;
    }
    if(this.battle.sidesSwitched === true){
      var enemy = this.battle.p1.active[0];
      var me = this.battle.p2.active[0];
    }
    else{
      var enemy = this.battle.p2.active[0];
      var me = this.battle.p1.active[0];
    }
    var format = toID(this.battle.tier);
    if (!format || !format.includes('random')) return original;


    var speciesEnemy = Dex.species.get(enemy.speciesForme);
    if (!speciesEnemy) return original;
    var speciesMe = Dex.species.get(me.speciesForme);
    if (!speciesMe) return original;

    var gen = Number(format.charAt(3));
    var letsgo = format.includes('letsgo');
    var gameType = this.battle.gameType;

    if (!['singles', 'doubles'].includes(gameType)) {
      format = 'gen' + gen + 'randomdoublesbattle';
    } else if (format.includes('monotype') || format.includes('unrated')) {
      format = 'gen' + gen + 'randombattle';
    }
    if (!DATA[format]) return original;


    // Enemy Stats
    var dataEnemy = DATA[format][speciesEnemy.name === 'Zoroark' ? 0 : enemy.level];
    if (!dataEnemy) return original;

    var cosmetic = speciesEnemy.cosmeticFormes && speciesEnemy.cosmeticFormes.includes(speciesEnemy.name);
    var idEnemy = toID((speciesEnemy.forme === 'Gmax' || cosmetic)
      ? speciesEnemy.baseSpecies : speciesEnemy.battleOnly || speciesEnemy.name);
    if (idEnemy.startsWith('pikachu')) idEnemy = idEnemy.endsWith('gmax') ? 'pikachugmax' : 'pikachu';
    var forme = cosmetic ? speciesEnemy.baseSpecies : enemy.speciesForme;
    if (forme.startsWith('Pikachu')) forme = forme.endsWith('Gmax') ? 'Pikachu-Gmax' : 'Pikachu';

    dataEnemy = dataEnemy[idEnemy];
    if (!dataEnemy) return original;

    var statsEnemy = getStats(gen, gameType, letsgo, speciesEnemy, dataEnemy[0], null , this.getPokemonTypes(enemy),enemy);
  



    // Me

    var dataMe = DATA[format][speciesMe.name === 'Zoroark' ? 0 : me.level];
    if (!dataMe) return original;

    var cosmetic = speciesMe.cosmeticFormes && speciesMe.cosmeticFormes.includes(speciesMe.name);
    var idMe = toID((speciesMe.forme === 'Gmax' || cosmetic)
      ? speciesMe.baseSpecies : speciesMe.battleOnly || speciesMe.name);
    if (idMe.startsWith('pikachu')) idMe = idMe.endsWith('gmax') ? 'pikachugmax' : 'pikachu';
    var forme = cosmetic ? speciesMe.baseSpecies : me.speciesForme;
    if (forme.startsWith('Pikachu')) forme = forme.endsWith('Gmax') ? 'Pikachu-Gmax' : 'Pikachu';
    dataMe = dataMe[idMe];
    if (!dataMe) return original;
    var statsMe = getStats(gen, gameType, letsgo, speciesMe, dataMe[0], null , this.getPokemonTypes(me),me);
    var buf = original;
    var bp = clientMove.basePower;
    buf += '<div style="border-top: 1px solid #888; background: #dedede">';
    if(serverMove === 'maxmove'){
      clientMove.basePower = clientMove.maxMove.basePower;
      buf += getItemModi(statsMe,statsEnemy,dataEnemy, dataMe, serverPokemon, me, enemy, this.getPokemonTypes(me), this.getPokemonTypes(enemy),clientMove,this.battle, true)
      clientMove.basePower = bp;
    }
    else{
      buf += getItemModi(statsMe,statsEnemy,dataEnemy, dataMe, serverPokemon, me, enemy, this.getPokemonTypes(me), this.getPokemonTypes(enemy),clientMove,this.battle, false)
    }
    return buf;
  }

  function getItemModi(statsMe,statsEnemy,dataEnemy, dataMe, serverMe, me, enemy, typesMe, typesEnemy,clientMove,battle, max){
    
    var buf = "";
    switch(serverMe.item){
      case 'choicespecs':
        if(clientMove.category === "Special" && !max){
          var spa = statsMe.atk;
          statsMe.spa *= 1.5;

          dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle);
          statsMe.spa = spa;
        }
        break;
      case 'choiceband':
        if(clientMove.category === "Physical" && !max){
          var atk = statsMe.atk;
          statsMe.atk *= 1.5;
          dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle);
          statsMe.atk = atk;
        }
        break;
      case 'lifeorb':
          dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle, 1.3);
          break;
      case 'griseousorb':
          if(clientMove.type === 'Dragon' || clientMove.type === 'Ghost'){
            dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle, 1.2);
          }
          break;
      case 'magnet':
          if(clientMove.type === 'Electric'){
            dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle, 1.2);
          }
          break;
      case 'thickclub':
          var atk = statsMe.atk;
          statsMe.atk *= 2;
          dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle);
          statsMe.atk = atk;
          break;
      case 'souldew':
          if(clientMove.type === 'Psychic' || clientMove.type === 'Dragon'){
            dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle, 1.2);
          }
          break;
      case 'lightball':
          var stm = statsMe;
          statsMe.atk *= 2;
          statsMe.spa *= 2;
          dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle, 1.2);
          statsMe = stm;
          break;        
      default:
        dmg = getDmg(statsMe,statsEnemy,me,enemy,typesMe, typesEnemy, clientMove,dataMe,dataEnemy, battle);
        break;
    }
    buf += '<p><small>Damage:</small> ' + dmg[0] + '% - ' + dmg[1] + '% </p>';

    return buf;
  }
  function getBoosts(stats, pokemon){
    if(pokemon.boosts.atk){
      switch(pokemon.boosts.atk){
        case -6:stats.atk *= 0.25; break;
        case -5:stats.atk *= 0.285; break;
        case -4:stats.atk *= 0.333;break;
        case -3:stats.atk *= 0.4;break;
        case -2:stats.atk *= 0.5;break;
        case -1:stats.atk *= 0.666;break;
        case 1:stats.atk *= 1.5;break;
        case 2:stats.atk *= 2;break;
        case 3:stats.atk *= 2.5;break;
        case 4:stats.atk *= 3;break;
        case 5:stats.atk *= 3.5;break;
        case 6:stats.atk *= 4;break;
      }
      stats.atk = Math.floor(stats.atk);

    }
    if(pokemon.boosts.spa){
      switch(pokemon.boosts.spa){
        case -6:stats.spa *= 0.25; break;
        case -5:stats.spa *= 0.285; break;
        case -4:stats.spa *= 0.333;break;
        case -3:stats.spa *= 0.4;break;
        case -2:stats.spa *= 0.5;break;
        case -1:stats.spa *= 0.666;break;
        case 1:stats.spa *= 1.5;break;
        case 2:stats.spa *= 2;break;
        case 3:stats.spa *= 2.5;break;
        case 4:stats.spa *= 3;break;
        case 5:stats.spa *= 3.5;break;
        case 6:stats.spa *= 4;break;
      }
      stats.spa = Math.floor(stats.spa);

    }
    if(pokemon.boosts.def){
      switch(pokemon.boosts.def){
        case -6:stats.def *= 0.25; break;
        case -5:stats.def *= 0.285; break;
        case -4:stats.def *= 0.333;break;
        case -3:stats.def *= 0.4;break;
        case -2:stats.def *= 0.5;break;
        case -1:stats.def *= 0.666;break;
        case 1:stats.def *= 1.5;break;
        case 2:stats.def *= 2;break;
        case 3:stats.def *= 2.5;break;
        case 4:stats.def *= 3;break;
        case 5:stats.def *= 3.5;break;
        case 6:stats.def *= 4;break;
      }
      stats.def = Math.floor(stats.def);

    }
    if(pokemon.boosts.spd){
      switch(pokemon.boosts.spd){
        case -6:stats.spd *= 0.25; break;
        case -5:stats.spd *= 0.285; break;
        case -4:stats.spd *= 0.333;break;
        case -3:stats.spd *= 0.4;break;
        case -2:stats.spd *= 0.5;break;
        case -1:stats.spd *= 0.666;break;
        case 1:stats.spd *= 1.5;break;
        case 2:stats.spd *= 2;break;
        case 3:stats.spd *= 2.5;break;
        case 4:stats.spd *= 3;break;
        case 5:stats.spd *= 3.5;break;
        case 6:stats.spd *= 4;break;
      }
      stats.spd = Math.floor(stats.spd);

    }
    if(pokemon.boosts.spe){
      switch(pokemon.boosts.spe){
        case -6:stats.spe *= 0.25; break;
        case -5:stats.spe *= 0.285; break;
        case -4:stats.spe *= 0.333;break;
        case -3:stats.spe *= 0.4;break;
        case -2:stats.spe *= 0.5;break;
        case -1:stats.spe *= 0.666;break;
        case 1:stats.spe *= 1.5;break;
        case 2:stats.spe *= 2;break;
        case 3:stats.spe *= 2.5;break;
        case 4:stats.spe *= 3;break;
        case 5:stats.spe *= 3.5;break;
        case 6:stats.spe *= 4;break;
      }
      stats.spe = Math.floor(stats.spe);
    }
    return stats;
    
  }

  function getDmg(statsMe, statsEnemy, me, enemy, typeMe, typeEnemy, clientMove, dataMe, dataEnemy, battle, modi = 1){
    var at = clientMove.category === 'Physical' ? statsMe.atk : statsMe.spa;
    var df = clientMove.category === 'Physical' ? statsEnemy.def : statsEnemy.spd;
    if(clientMove.name === 'Psyshock'){
      df = statsEnemy.def;
    }
    var weather = 1;
    var stab = 1;
    var type = 1;
    var burn = 1;
    var grounded = true;
    for(var typ of typeEnemy){
      if(typ === 'Flying'){
        grounded === false;
      }
    }
    for(var ab of dataEnemy[0].abilities){
      if(ab === 'Levitate'){
        grounded === false;
      }
    }
    for(var typ of typeMe){
      if(typ === clientMove.type){
        stab = 1.5;
      }
    }
    const typeEff = ShowdownEnhancedTooltip.getTypeEff(typeEnemy);
    const multiplierKeys = [4, 2, .5, .25, 0];
    multiplierKeys.forEach((multiplierKey) => {
      if (typeEff[multiplierKey].length > 0) {
        typeEff[multiplierKey].map(effect => effect === clientMove.type ? type = multiplierKey : '');
        }
    });

    if(me.status === "Burn" && clientMove.category === 'Physical'){
      burn = .5;
    }
    if(battle.weather !== ''){
      if(battle.weather === 'sandstorm'){
        statsEnemy.spd *= 1.5;
      }
      weather = getWeatherModi(battle.weather,grounded, clientMove);
    }
    if(battle.pseudoWeather[0] !== ''){
      var weather2 = getWeatherModi(battle.pseudoWeather[0],grounded, clientMove);
      weather = weather2 === 1 ? weather : weather2;
    }
    if(clientMove.basePower > 0){
      var a = Math.floor((2*dataMe[0].level)/5);
      var b = Math.floor(( a + 2) * clientMove.basePower * (at/df));
      var c = Math.floor((b / 50) +2);
      var dmg = Math.floor(c * weather);
      var mindmg = Math.floor(dmg * 0.85);
      dmg = Math.floor(dmg * stab);
      dmg = Math.floor(dmg * type);
      dmg = Math.floor(dmg * burn);
      dmg = Math.floor(dmg * modi);
      mindmg = Math.floor(mindmg * stab);
      mindmg = Math.floor(mindmg * type);
      mindmg = Math.floor(mindmg * burn);
      mindmg = Math.floor(mindmg * modi);
      var dmgmin = Math.floor(mindmg / statsEnemy.hp * 1000)/10;
      var dmgmax = Math.floor(dmg / statsEnemy.hp * 1000)/10;
      return [dmgmin,dmgmax];
    }
    return 0;
  }
  function getWeatherModi(weather, grounded, move){
    switch(weather){
      case "raindance":
        if(move.type == "Water"){
          return 1.5;
        }
        if(move.type == "Fire"){
          return .5;
        }
        break;
      case "sunnyday":
        if(move.type == "Fire"){
          return 1.5;
        }
        if(move.type == "Water"){
          return .5;
        }
        break;
    }
    if(grounded){
      switch(weather){
        case "Psychic Terrain":
          if(move.type === 'Psychic'){
            return 1.3;
          }
          break;
        case "Electic Terrain":
          if(move.type === 'Electic'){
            return 1.3;
          }
          break;
        case "Grassy Terrain":
          if(move.type === 'Grass'){
            return 1.3;
          } 
          if(move.name === 'Bulldoze' || move.name === 'Earthquake' || move.name === 'Magnitude'){
            return .5;
          }
          break;
        case "Misty Terrain":
          if(move.type === 'Dragon'){
            return .5;
          }
          break;
      }
    }
    return 1;
  }
  function getStats(gen, gameType, letsgo, species, data, name, types, pokemon) {
    var stats = {};
    for (var stat in species.baseStats) {
      stats[stat] = calc(
        gen,
        stat,
        species.baseStats[stat],
        'ivs' in data && stat in data.ivs ? data.ivs[stat] : (gen < 3 ? 30 : 31),
        'evs' in data && stat in data.evs ? data.evs[stat] : (gen < 3 ? 255 : letsgo ? 0 : 85),
        data.level,
        letsgo);
    }
    stats = getBoosts(stats,pokemon);
    return stats;
  }
}